profunctors-5.6.2: Profunctors

Copyright | (C) 2011-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Data.Profunctor.Types

Description

For a good explanation of profunctors in Haskell see Dan Piponi's article:

http://blog.sigfpe.com/2011/07/profunctors-in-haskell.html

For more information on strength and costrength, see:

http://comonad.com/reader/2008/deriving-strength-from-laziness/

Synopsis

- class Profunctor (p :: Type -> Type -> Type) where
  - dimap :: (a -> b) -> (c -> d) -> p b c -> p a d
  - lmap :: (a -> b) -> p b c -> p a c
  - rmap :: (b -> c) -> p a b -> p a c
- newtype Star (f :: k -> Type) d (c :: k) = Star {
  - runStar :: d -> f c
  }
- newtype Costar (f :: k -> Type) (d :: k) c = Costar {
  - runCostar :: f d -> c
  }
- newtype WrappedArrow (p :: k -> k1 -> Type) (a :: k) (b :: k1) = WrapArrow {
  - unwrapArrow :: p a b
  }
- newtype Forget r a (b :: k) = Forget {
  - runForget :: a -> r
  }
- type (:->) (p :: k -> k1 -> Type) (q :: k -> k1 -> Type) = forall (a :: k) (b :: k1). p a b -> q a b

# Documentation

class Profunctor (p :: Type -> Type -> Type) where #

Formally, the class `Profunctor` represents a profunctor from `Hask` -> `Hask`.

Intuitively it is a bifunctor where the first argument is contravariant and the second argument is covariant.

You can define a `Profunctor` by either defining `dimap` or by defining both `lmap` and `rmap`.

If you supply `dimap`, you should ensure that:

    dimap id id ≡ id

If you supply `lmap` and `rmap`, ensure:

    lmap id ≡ id
    rmap id ≡ id

If you supply both, you should also ensure:

    dimap f g ≡ lmap f . rmap g

These ensure by parametricity:

    dimap (f . g) (h . i) ≡ dimap g h . dimap f i
    lmap (f . g) ≡ lmap g . lmap f
    rmap (f . g) ≡ rmap f . rmap g

Minimal complete definition

dimap | lmap, rmap

Methods

dimap :: (a -> b) -> (c -> d) -> p b c -> p a d #

Map over both arguments at the same time.

    dimap f g ≡ lmap f . rmap g

lmap :: (a -> b) -> p b c -> p a c #

Map the first argument contravariantly.

    lmap f ≡ dimap f id

rmap :: (b -> c) -> p a b -> p a c #

Map the second argument covariantly.

    rmap ≡ dimap id

#### Instances

Instances details

Monad m => Profunctor (Kleisli m) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Kleisli m b c -> Kleisli m a d # lmap :: (a -> b) -> Kleisli m b c -> Kleisli m a c # rmap :: (b -> c) -> Kleisli m a b -> Kleisli m a c # (#.) :: forall a b c q. Coercible c b => q b c -> Kleisli m a b -> Kleisli m a c # (.#) :: forall a b c q. Coercible b a => Kleisli m b c -> q a b -> Kleisli m a c #
Profunctor (CopastroSum p) # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> CopastroSum p b c -> CopastroSum p a d #

lmap :: (a -> b) -> CopastroSum p b c -> CopastroSum p a c #

rmap :: (b -> c) -> CopastroSum p a b -> CopastroSum p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> CopastroSum p a b -> CopastroSum p a c #

(.#) :: forall a b c q. Coercible b a => CopastroSum p b c -> q a b -> CopastroSum p a c #

Profunctor (CotambaraSum p) # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> CotambaraSum p b c -> CotambaraSum p a d #

lmap :: (a -> b) -> CotambaraSum p b c -> CotambaraSum p a c #

rmap :: (b -> c) -> CotambaraSum p a b -> CotambaraSum p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> CotambaraSum p a b -> CotambaraSum p a c #

(.#) :: forall a b c q. Coercible b a => CotambaraSum p b c -> q a b -> CotambaraSum p a c #

Profunctor (PastroSum p) # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> PastroSum p b c -> PastroSum p a d #

lmap :: (a -> b) -> PastroSum p b c -> PastroSum p a c #

rmap :: (b -> c) -> PastroSum p a b -> PastroSum p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> PastroSum p a b -> PastroSum p a c #

(.#) :: forall a b c q. Coercible b a => PastroSum p b c -> q a b -> PastroSum p a c #

Profunctor p => Profunctor (TambaraSum p) # |

Instance details

Defined in Data.Profunctor.Choice

Methods

dimap :: (a -> b) -> (c -> d) -> TambaraSum p b c -> TambaraSum p a d #

lmap :: (a -> b) -> TambaraSum p b c -> TambaraSum p a c #

rmap :: (b -> c) -> TambaraSum p a b -> TambaraSum p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> TambaraSum p a b -> TambaraSum p a c #

(.#) :: forall a b c q. Coercible b a => TambaraSum p b c -> q a b -> TambaraSum p a c #

Profunctor p => Profunctor (Closure p) # |
Instance details Defined in Data.Profunctor.Closed Methods dimap :: (a -> b) -> (c -> d) -> Closure p b c -> Closure p a d # lmap :: (a -> b) -> Closure p b c -> Closure p a c # rmap :: (b -> c) -> Closure p a b -> Closure p a c # (#.) :: forall a b c q. Coercible c b => q b c -> Closure p a b -> Closure p a c # (.#) :: forall a b c q. Coercible b a => Closure p b c -> q a b -> Closure p a c #
Profunctor (Environment p) # |

Instance details

Defined in Data.Profunctor.Closed

Methods

dimap :: (a -> b) -> (c -> d) -> Environment p b c -> Environment p a d #

lmap :: (a -> b) -> Environment p b c -> Environment p a c #

rmap :: (b -> c) -> Environment p a b -> Environment p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Environment p a b -> Environment p a c #

(.#) :: forall a b c q. Coercible b a => Environment p b c -> q a b -> Environment p a c #

Profunctor p => Profunctor (CofreeMapping p) # |

Instance details

Defined in Data.Profunctor.Mapping

Methods

dimap :: (a -> b) -> (c -> d) -> CofreeMapping p b c -> CofreeMapping p a d #

lmap :: (a -> b) -> CofreeMapping p b c -> CofreeMapping p a c #

rmap :: (b -> c) -> CofreeMapping p a b -> CofreeMapping p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> CofreeMapping p a b -> CofreeMapping p a c #

(.#) :: forall a b c q. Coercible b a => CofreeMapping p b c -> q a b -> CofreeMapping p a c #

Profunctor (FreeMapping p) # |

Instance details

Defined in Data.Profunctor.Mapping

Methods

dimap :: (a -> b) -> (c -> d) -> FreeMapping p b c -> FreeMapping p a d #

lmap :: (a -> b) -> FreeMapping p b c -> FreeMapping p a c #

rmap :: (b -> c) -> FreeMapping p a b -> FreeMapping p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> FreeMapping p a b -> FreeMapping p a c #

(.#) :: forall a b c q. Coercible b a => FreeMapping p b c -> q a b -> FreeMapping p a c #

Profunctor (Copastro p) # |

Instance details

Defined in Data.Profunctor.Strong

Methods

dimap :: (a -> b) -> (c -> d) -> Copastro p b c -> Copastro p a d #

lmap :: (a -> b) -> Copastro p b c -> Copastro p a c #

rmap :: (b -> c) -> Copastro p a b -> Copastro p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Copastro p a b -> Copastro p a c #

(.#) :: forall a b c q. Coercible b a => Copastro p b c -> q a b -> Copastro p a c #

Profunctor (Cotambara p) # |

Instance details

Defined in Data.Profunctor.Strong

Methods

dimap :: (a -> b) -> (c -> d) -> Cotambara p b c -> Cotambara p a d #

lmap :: (a -> b) -> Cotambara p b c -> Cotambara p a c #

rmap :: (b -> c) -> Cotambara p a b -> Cotambara p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Cotambara p a b -> Cotambara p a c #

(.#) :: forall a b c q. Coercible b a => Cotambara p b c -> q a b -> Cotambara p a c #

Profunctor (Pastro p) # |
Instance details Defined in Data.Profunctor.Strong Methods dimap :: (a -> b) -> (c -> d) -> Pastro p b c -> Pastro p a d # lmap :: (a -> b) -> Pastro p b c -> Pastro p a c # rmap :: (b -> c) -> Pastro p a b -> Pastro p a c # (#.) :: forall a b c q. Coercible c b => q b c -> Pastro p a b -> Pastro p a c # (.#) :: forall a b c q. Coercible b a => Pastro p b c -> q a b -> Pastro p a c #
Profunctor p => Profunctor (Tambara p) # |
Instance details Defined in Data.Profunctor.Strong Methods dimap :: (a -> b) -> (c -> d) -> Tambara p b c -> Tambara p a d # lmap :: (a -> b) -> Tambara p b c -> Tambara p a c # rmap :: (b -> c) -> Tambara p a b -> Tambara p a c # (#.) :: forall a b c q. Coercible c b => q b c -> Tambara p a b -> Tambara p a c # (.#) :: forall a b c q. Coercible b a => Tambara p b c -> q a b -> Tambara p a c #
Profunctor p => Profunctor (CofreeTraversing p) # |

Instance details

Defined in Data.Profunctor.Traversing

Methods

dimap :: (a -> b) -> (c -> d) -> CofreeTraversing p b c -> CofreeTraversing p a d #

lmap :: (a -> b) -> CofreeTraversing p b c -> CofreeTraversing p a c #

rmap :: (b -> c) -> CofreeTraversing p a b -> CofreeTraversing p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> CofreeTraversing p a b -> CofreeTraversing p a c #

(.#) :: forall a b c q. Coercible b a => CofreeTraversing p b c -> q a b -> CofreeTraversing p a c #

Profunctor (FreeTraversing p) # |

Instance details

Defined in Data.Profunctor.Traversing

Methods

dimap :: (a -> b) -> (c -> d) -> FreeTraversing p b c -> FreeTraversing p a d #

lmap :: (a -> b) -> FreeTraversing p b c -> FreeTraversing p a c #

rmap :: (b -> c) -> FreeTraversing p a b -> FreeTraversing p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> FreeTraversing p a b -> FreeTraversing p a c #

(.#) :: forall a b c q. Coercible b a => FreeTraversing p b c -> q a b -> FreeTraversing p a c #

Profunctor (Coyoneda p) # |

Instance details

Defined in Data.Profunctor.Yoneda

Methods

dimap :: (a -> b) -> (c -> d) -> Coyoneda p b c -> Coyoneda p a d #

lmap :: (a -> b) -> Coyoneda p b c -> Coyoneda p a c #

rmap :: (b -> c) -> Coyoneda p a b -> Coyoneda p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Coyoneda p a b -> Coyoneda p a c #

(.#) :: forall a b c q. Coercible b a => Coyoneda p b c -> q a b -> Coyoneda p a c #

Profunctor (Yoneda p) # |
Instance details Defined in Data.Profunctor.Yoneda Methods dimap :: (a -> b) -> (c -> d) -> Yoneda p b c -> Yoneda p a d # lmap :: (a -> b) -> Yoneda p b c -> Yoneda p a c # rmap :: (b -> c) -> Yoneda p a b -> Yoneda p a c # (#.) :: forall a b c q. Coercible c b => q b c -> Yoneda p a b -> Yoneda p a c # (.#) :: forall a b c q. Coercible b a => Yoneda p b c -> q a b -> Yoneda p a c #
Profunctor (Tagged :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Tagged b c -> Tagged a d # lmap :: (a -> b) -> Tagged b c -> Tagged a c # rmap :: (b -> c) -> Tagged a b -> Tagged a c # (#.) :: forall a b c q. Coercible c b => q b c -> Tagged a b -> Tagged a c # (.#) :: forall a b c q. Coercible b a => Tagged b c -> q a b -> Tagged a c #
Functor w => Profunctor (Cokleisli w) # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Cokleisli w b c -> Cokleisli w a d #

lmap :: (a -> b) -> Cokleisli w b c -> Cokleisli w a c #

rmap :: (b -> c) -> Cokleisli w a b -> Cokleisli w a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Cokleisli w a b -> Cokleisli w a c #

(.#) :: forall a b c q. Coercible b a => Cokleisli w b c -> q a b -> Cokleisli w a c #

Functor f => Profunctor (Costar f) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Costar f b c -> Costar f a d # lmap :: (a -> b) -> Costar f b c -> Costar f a c # rmap :: (b -> c) -> Costar f a b -> Costar f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Costar f a b -> Costar f a c # (.#) :: forall a b c q. Coercible b a => Costar f b c -> q a b -> Costar f a c #
Profunctor (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Forget r b c -> Forget r a d # lmap :: (a -> b) -> Forget r b c -> Forget r a c # rmap :: (b -> c) -> Forget r a b -> Forget r a c # (#.) :: forall a b c q. Coercible c b => q b c -> Forget r a b -> Forget r a c # (.#) :: forall a b c q. Coercible b a => Forget r b c -> q a b -> Forget r a c #
Functor f => Profunctor (Star f) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Star f b c -> Star f a d # lmap :: (a -> b) -> Star f b c -> Star f a c # rmap :: (b -> c) -> Star f a b -> Star f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Star f a b -> Star f a c # (.#) :: forall a b c q. Coercible b a => Star f b c -> q a b -> Star f a c #
Profunctor (->) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> (b -> c) -> a -> d # lmap :: (a -> b) -> (b -> c) -> a -> c # rmap :: (b -> c) -> (a -> b) -> a -> c # (#.) :: forall a b c q. Coercible c b => q b c -> (a -> b) -> a -> c # (.#) :: forall a b c q. Coercible b a => (b -> c) -> q a b -> a -> c #
Contravariant f => Profunctor (Clown f :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Clown f b c -> Clown f a d # lmap :: (a -> b) -> Clown f b c -> Clown f a c # rmap :: (b -> c) -> Clown f a b -> Clown f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Clown f a b -> Clown f a c # (.#) :: forall a b c q. Coercible b a => Clown f b c -> q a b -> Clown f a c #
Functor f => Profunctor (Joker f :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Joker f b c -> Joker f a d # lmap :: (a -> b) -> Joker f b c -> Joker f a c # rmap :: (b -> c) -> Joker f a b -> Joker f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Joker f a b -> Joker f a c # (.#) :: forall a b c q. Coercible b a => Joker f b c -> q a b -> Joker f a c #
Profunctor p => Profunctor (Codensity p) # |

Instance details

Defined in Data.Profunctor.Ran

Methods

dimap :: (a -> b) -> (c -> d) -> Codensity p b c -> Codensity p a d #

lmap :: (a -> b) -> Codensity p b c -> Codensity p a c #

rmap :: (b -> c) -> Codensity p a b -> Codensity p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Codensity p a b -> Codensity p a c #

(.#) :: forall a b c q. Coercible b a => Codensity p b c -> q a b -> Codensity p a c #

Arrow p => Profunctor (WrappedArrow p) # |

Instance details

Defined in Data.Profunctor.Types

Methods

dimap :: (a -> b) -> (c -> d) -> WrappedArrow p b c -> WrappedArrow p a d #

lmap :: (a -> b) -> WrappedArrow p b c -> WrappedArrow p a c #

rmap :: (b -> c) -> WrappedArrow p a b -> WrappedArrow p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> WrappedArrow p a b -> WrappedArrow p a c #

(.#) :: forall a b c q. Coercible b a => WrappedArrow p b c -> q a b -> WrappedArrow p a c #

(Profunctor p, Profunctor q) => Profunctor (Product p q) # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Product p q b c -> Product p q a d #

lmap :: (a -> b) -> Product p q b c -> Product p q a c #

rmap :: (b -> c) -> Product p q a b -> Product p q a c #

(#.) :: forall a b c q0. Coercible c b => q0 b c -> Product p q a b -> Product p q a c #

(.#) :: forall a b c q0. Coercible b a => Product p q b c -> q0 a b -> Product p q a c #

(Profunctor p, Profunctor q) => Profunctor (Sum p q) # |
Instance details Defined in Data.Profunctor.Unsafe Methods dimap :: (a -> b) -> (c -> d) -> Sum p q b c -> Sum p q a d # lmap :: (a -> b) -> Sum p q b c -> Sum p q a c # rmap :: (b -> c) -> Sum p q a b -> Sum p q a c # (#.) :: forall a b c q0. Coercible c b => q0 b c -> Sum p q a b -> Sum p q a c # (.#) :: forall a b c q0. Coercible b a => Sum p q b c -> q0 a b -> Sum p q a c #
(Functor f, Profunctor p) => Profunctor (Tannen f p) # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Tannen f p b c -> Tannen f p a d #

lmap :: (a -> b) -> Tannen f p b c -> Tannen f p a c #

rmap :: (b -> c) -> Tannen f p a b -> Tannen f p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Tannen f p a b -> Tannen f p a c #

(.#) :: forall a b c q. Coercible b a => Tannen f p b c -> q a b -> Tannen f p a c #

(Functor f, Profunctor p) => Profunctor (Cayley f p) # |

Instance details

Defined in Data.Profunctor.Cayley

Methods

dimap :: (a -> b) -> (c -> d) -> Cayley f p b c -> Cayley f p a d #

lmap :: (a -> b) -> Cayley f p b c -> Cayley f p a c #

rmap :: (b -> c) -> Cayley f p a b -> Cayley f p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Cayley f p a b -> Cayley f p a c #

(.#) :: forall a b c q. Coercible b a => Cayley f p b c -> q a b -> Cayley f p a c #

(Profunctor p, Profunctor q) => Profunctor (Procompose p q) # |

Instance details

Defined in Data.Profunctor.Composition

Methods

dimap :: (a -> b) -> (c -> d) -> Procompose p q b c -> Procompose p q a d #

lmap :: (a -> b) -> Procompose p q b c -> Procompose p q a c #

rmap :: (b -> c) -> Procompose p q a b -> Procompose p q a c #

(#.) :: forall a b c q0. Coercible c b => q0 b c -> Procompose p q a b -> Procompose p q a c #

(.#) :: forall a b c q0. Coercible b a => Procompose p q b c -> q0 a b -> Procompose p q a c #

(Profunctor p, Profunctor q) => Profunctor (Rift p q) # |
Instance details Defined in Data.Profunctor.Composition Methods dimap :: (a -> b) -> (c -> d) -> Rift p q b c -> Rift p q a d # lmap :: (a -> b) -> Rift p q b c -> Rift p q a c # rmap :: (b -> c) -> Rift p q a b -> Rift p q a c # (#.) :: forall a b c q0. Coercible c b => q0 b c -> Rift p q a b -> Rift p q a c # (.#) :: forall a b c q0. Coercible b a => Rift p q b c -> q0 a b -> Rift p q a c #
(Profunctor p, Profunctor q) => Profunctor (Ran p q) # |
Instance details Defined in Data.Profunctor.Ran Methods dimap :: (a -> b) -> (c -> d) -> Ran p q b c -> Ran p q a d # lmap :: (a -> b) -> Ran p q b c -> Ran p q a c # rmap :: (b -> c) -> Ran p q a b -> Ran p q a c # (#.) :: forall a b c q0. Coercible c b => q0 b c -> Ran p q a b -> Ran p q a c # (.#) :: forall a b c q0. Coercible b a => Ran p q b c -> q0 a b -> Ran p q a c #
(Profunctor p, Functor f, Functor g) => Profunctor (Biff p f g) # |

Instance details

Defined in Data.Profunctor.Unsafe

Methods

dimap :: (a -> b) -> (c -> d) -> Biff p f g b c -> Biff p f g a d #

lmap :: (a -> b) -> Biff p f g b c -> Biff p f g a c #

rmap :: (b -> c) -> Biff p f g a b -> Biff p f g a c #

(#.) :: forall a b c q. Coercible c b => q b c -> Biff p f g a b -> Biff p f g a c #

(.#) :: forall a b c q. Coercible b a => Biff p f g b c -> q a b -> Biff p f g a c #

newtype Star (f :: k -> Type) d (c :: k) #

Lift a `Functor` into a `Profunctor` (forwards).

`Star` has a polymorphic kind since `5.6`.

Constructors

Star |

Fields

- runStar :: d -> f c

#### Instances

Instances details

Monad f => Category (Star f :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods id :: Star f a a # (.) :: Star f b c -> Star f a b -> Star f a c #
Applicative f => Choice (Star f) # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: Star f a b -> Star f (Either a c) (Either b c) # right' :: Star f a b -> Star f (Either c a) (Either c b) #
Traversable f => Cochoice (Star f) # |
Instance details Defined in Data.Profunctor.Choice Methods unleft :: Star f (Either a d) (Either b d) -> Star f a b # unright :: Star f (Either d a) (Either d b) -> Star f a b #
Distributive f => Closed (Star f) # |
Instance details Defined in Data.Profunctor.Closed Methods closed :: Star f a b -> Star f (x -> a) (x -> b) #
(Applicative m, Distributive m) => Mapping (Star m) # |
Instance details Defined in Data.Profunctor.Mapping Methods map' :: Functor f => Star m a b -> Star m (f a) (f b) # roam :: ((a -> b) -> s -> t) -> Star m a b -> Star m s t #
Functor f => Representable (Star f) # |

Instance details

Defined in Data.Profunctor.Rep

Associated Types

type Rep (Star f) |
Instance details Defined in Data.Profunctor.Rep type Rep (Star f) = f

Methods

tabulate :: (d -> Rep (Star f) c) -> Star f d c #

Functor m => Strong (Star m) # |
Instance details Defined in Data.Profunctor.Strong Methods first' :: Star m a b -> Star m (a, c) (b, c) # second' :: Star m a b -> Star m (c, a) (c, b) #
Applicative m => Traversing (Star m) # |
Instance details Defined in Data.Profunctor.Traversing Methods traverse' :: Traversable f => Star m a b -> Star m (f a) (f b) # wander :: (forall (f :: Type -> Type). Applicative f => (a -> f b) -> s -> f t) -> Star m a b -> Star m s t #
Functor f => Profunctor (Star f) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Star f b c -> Star f a d # lmap :: (a -> b) -> Star f b c -> Star f a c # rmap :: (b -> c) -> Star f a b -> Star f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Star f a b -> Star f a c # (.#) :: forall a b c q. Coercible b a => Star f b c -> q a b -> Star f a c #
Functor f => Sieve (Star f) f # |
Instance details Defined in Data.Profunctor.Sieve Methods sieve :: Star f a b -> a -> f b #
Contravariant f => Contravariant (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods contramap :: (a' -> a0) -> Star f a a0 -> Star f a a' # (>$) :: b -> Star f a b -> Star f a a0 #
Distributive f => Distributive (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods distribute :: Functor f0 => f0 (Star f a a0) -> Star f a (f0 a0) # collect :: Functor f0 => (a0 -> Star f a b) -> f0 a0 -> Star f a (f0 b) # distributeM :: Monad m => m (Star f a a0) -> Star f a (m a0) # collectM :: Monad m => (a0 -> Star f a b) -> m a0 -> Star f a (m b) #
Alternative f => Alternative (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods empty :: Star f a a0 # (<|>) :: Star f a a0 -> Star f a a0 -> Star f a a0 # some :: Star f a a0 -> Star f a [a0] # many :: Star f a a0 -> Star f a [a0] #
Applicative f => Applicative (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods pure :: a0 -> Star f a a0 # (<*>) :: Star f a (a0 -> b) -> Star f a a0 -> Star f a b # liftA2 :: (a0 -> b -> c) -> Star f a a0 -> Star f a b -> Star f a c # (*>) :: Star f a a0 -> Star f a b -> Star f a b # (<*) :: Star f a a0 -> Star f a b -> Star f a a0 #
Functor f => Functor (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Star f a a0 -> Star f a b # (<$) :: a0 -> Star f a b -> Star f a a0 #
Monad f => Monad (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods (>>=) :: Star f a a0 -> (a0 -> Star f a b) -> Star f a b # (>>) :: Star f a a0 -> Star f a b -> Star f a b # return :: a0 -> Star f a a0 #
MonadPlus f => MonadPlus (Star f a) # |
Instance details Defined in Data.Profunctor.Types Methods mzero :: Star f a a0 # mplus :: Star f a a0 -> Star f a a0 -> Star f a a0 #
type Rep (Star f) # |
Instance details Defined in Data.Profunctor.Rep type Rep (Star f) = f

newtype Costar (f :: k -> Type) (d :: k) c #

Lift a `Functor` into a `Profunctor` (backwards).

`Costar` has a polymorphic kind since `5.6`.

Constructors

Costar |

Fields

- runCostar :: f d -> c

#### Instances

Instances details

Applicative f => Cochoice (Costar f) # |
Instance details Defined in Data.Profunctor.Choice Methods unleft :: Costar f (Either a d) (Either b d) -> Costar f a b # unright :: Costar f (Either d a) (Either d b) -> Costar f a b #
Functor f => Closed (Costar f) # |
Instance details Defined in Data.Profunctor.Closed Methods closed :: Costar f a b -> Costar f (x -> a) (x -> b) #
Functor f => Corepresentable (Costar f) # |

Instance details

Defined in Data.Profunctor.Rep

Associated Types

type Corep (Costar f) |
Instance details Defined in Data.Profunctor.Rep type Corep (Costar f) = f

Methods

cotabulate :: (Corep (Costar f) d -> c) -> Costar f d c #

Functor f => Costrong (Costar f) # |
Instance details Defined in Data.Profunctor.Strong Methods unfirst :: Costar f (a, d) (b, d) -> Costar f a b # unsecond :: Costar f (d, a) (d, b) -> Costar f a b #
Functor f => Profunctor (Costar f) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Costar f b c -> Costar f a d # lmap :: (a -> b) -> Costar f b c -> Costar f a c # rmap :: (b -> c) -> Costar f a b -> Costar f a c # (#.) :: forall a b c q. Coercible c b => q b c -> Costar f a b -> Costar f a c # (.#) :: forall a b c q. Coercible b a => Costar f b c -> q a b -> Costar f a c #
Functor f => Cosieve (Costar f) f # |
Instance details Defined in Data.Profunctor.Sieve Methods cosieve :: Costar f a b -> f a -> b #
Distributive (Costar f d) # |
Instance details Defined in Data.Profunctor.Types Methods distribute :: Functor f0 => f0 (Costar f d a) -> Costar f d (f0 a) # collect :: Functor f0 => (a -> Costar f d b) -> f0 a -> Costar f d (f0 b) # distributeM :: Monad m => m (Costar f d a) -> Costar f d (m a) # collectM :: Monad m => (a -> Costar f d b) -> m a -> Costar f d (m b) #
Applicative (Costar f a) # |
Instance details Defined in Data.Profunctor.Types Methods pure :: a0 -> Costar f a a0 # (<*>) :: Costar f a (a0 -> b) -> Costar f a a0 -> Costar f a b # liftA2 :: (a0 -> b -> c) -> Costar f a a0 -> Costar f a b -> Costar f a c # (*>) :: Costar f a a0 -> Costar f a b -> Costar f a b # (<*) :: Costar f a a0 -> Costar f a b -> Costar f a a0 #
Functor (Costar f a) # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Costar f a a0 -> Costar f a b # (<$) :: a0 -> Costar f a b -> Costar f a a0 #
Monad (Costar f a) # |
Instance details Defined in Data.Profunctor.Types Methods (>>=) :: Costar f a a0 -> (a0 -> Costar f a b) -> Costar f a b # (>>) :: Costar f a a0 -> Costar f a b -> Costar f a b # return :: a0 -> Costar f a a0 #
type Corep (Costar f) # |
Instance details Defined in Data.Profunctor.Rep type Corep (Costar f) = f

newtype WrappedArrow (p :: k -> k1 -> Type) (a :: k) (b :: k1) #

Wrap an arrow for use as a `Profunctor`.

`WrappedArrow` has a polymorphic kind since `5.6`.

Constructors

WrapArrow |

Fields

- unwrapArrow :: p a b

#### Instances

Instances details

Category p => Category (WrappedArrow p :: k -> k -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods id :: forall (a :: k). WrappedArrow p a a # (.) :: forall (b :: k) (c :: k) (a :: k). WrappedArrow p b c -> WrappedArrow p a b -> WrappedArrow p a c #
Arrow p => Arrow (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Types Methods arr :: (b -> c) -> WrappedArrow p b c # first :: WrappedArrow p b c -> WrappedArrow p (b, d) (c, d) # second :: WrappedArrow p b c -> WrappedArrow p (d, b) (d, c) # (***) :: WrappedArrow p b c -> WrappedArrow p b' c' -> WrappedArrow p (b, b') (c, c') # (&&&) :: WrappedArrow p b c -> WrappedArrow p b c' -> WrappedArrow p b (c, c') #
ArrowApply p => ArrowApply (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Types Methods app :: WrappedArrow p (WrappedArrow p b c, b) c #
ArrowChoice p => ArrowChoice (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Types Methods left :: WrappedArrow p b c -> WrappedArrow p (Either b d) (Either c d) # right :: WrappedArrow p b c -> WrappedArrow p (Either d b) (Either d c) # (+++) :: WrappedArrow p b c -> WrappedArrow p b' c' -> WrappedArrow p (Either b b') (Either c c') # (|||) :: WrappedArrow p b d -> WrappedArrow p c d -> WrappedArrow p (Either b c) d #
ArrowLoop p => ArrowLoop (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Types Methods loop :: WrappedArrow p (b, d) (c, d) -> WrappedArrow p b c #
ArrowZero p => ArrowZero (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Types Methods zeroArrow :: WrappedArrow p b c #
ArrowChoice p => Choice (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: WrappedArrow p a b -> WrappedArrow p (Either a c) (Either b c) # right' :: WrappedArrow p a b -> WrappedArrow p (Either c a) (Either c b) #
ArrowLoop p => Costrong (WrappedArrow p) # |
Instance details Defined in Data.Profunctor.Strong Methods unfirst :: WrappedArrow p (a, d) (b, d) -> WrappedArrow p a b # unsecond :: WrappedArrow p (d, a) (d, b) -> WrappedArrow p a b #
Arrow p => Strong (WrappedArrow p) # | `Arrow` is `Strong` `Category`
Instance details Defined in Data.Profunctor.Strong Methods first' :: WrappedArrow p a b -> WrappedArrow p (a, c) (b, c) # second' :: WrappedArrow p a b -> WrappedArrow p (c, a) (c, b) #
Arrow p => Profunctor (WrappedArrow p) # |

Instance details

Defined in Data.Profunctor.Types

Methods

dimap :: (a -> b) -> (c -> d) -> WrappedArrow p b c -> WrappedArrow p a d #

lmap :: (a -> b) -> WrappedArrow p b c -> WrappedArrow p a c #

rmap :: (b -> c) -> WrappedArrow p a b -> WrappedArrow p a c #

(#.) :: forall a b c q. Coercible c b => q b c -> WrappedArrow p a b -> WrappedArrow p a c #

(.#) :: forall a b c q. Coercible b a => WrappedArrow p b c -> q a b -> WrappedArrow p a c #

newtype Forget r a (b :: k) #

`Forget` has a polymorphic kind since `5.6`.

Constructors

Forget |

Fields

- runForget :: a -> r

#### Instances

Instances details

Monoid r => Choice (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Choice Methods left' :: Forget r a b -> Forget r (Either a c) (Either b c) # right' :: Forget r a b -> Forget r (Either c a) (Either c b) #
Cochoice (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Choice Methods unleft :: Forget r (Either a d) (Either b d) -> Forget r a b # unright :: Forget r (Either d a) (Either d b) -> Forget r a b #
Representable (Forget r :: Type -> Type -> Type) # |

Instance details

Defined in Data.Profunctor.Rep

Associated Types

type Rep (Forget r :: Type -> Type -> Type) |
Instance details Defined in Data.Profunctor.Rep type Rep (Forget r :: Type -> Type -> Type) = Const r :: Type -> Type

Methods

tabulate :: (d -> Rep (Forget r :: Type -> Type -> Type) c) -> Forget r d c #

Strong (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Strong Methods first' :: Forget r a b -> Forget r (a, c) (b, c) # second' :: Forget r a b -> Forget r (c, a) (c, b) #
Monoid m => Traversing (Forget m :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Traversing Methods traverse' :: Traversable f => Forget m a b -> Forget m (f a) (f b) # wander :: (forall (f :: Type -> Type). Applicative f => (a -> f b) -> s -> f t) -> Forget m a b -> Forget m s t #
Profunctor (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods dimap :: (a -> b) -> (c -> d) -> Forget r b c -> Forget r a d # lmap :: (a -> b) -> Forget r b c -> Forget r a c # rmap :: (b -> c) -> Forget r a b -> Forget r a c # (#.) :: forall a b c q. Coercible c b => q b c -> Forget r a b -> Forget r a c # (.#) :: forall a b c q. Coercible b a => Forget r b c -> q a b -> Forget r a c #
Sieve (Forget r :: Type -> Type -> Type) (Const r :: Type -> Type) # |
Instance details Defined in Data.Profunctor.Sieve Methods sieve :: Forget r a b -> a -> Const r b #
Contravariant (Forget r a :: Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods contramap :: (a' -> a0) -> Forget r a a0 -> Forget r a a' # (>$) :: b -> Forget r a b -> Forget r a a0 #
Functor (Forget r a :: Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods fmap :: (a0 -> b) -> Forget r a a0 -> Forget r a b # (<$) :: a0 -> Forget r a b -> Forget r a a0 #
Foldable (Forget r a :: Type -> Type) # |

Instance details

Defined in Data.Profunctor.Types

Methods

fold :: Monoid m => Forget r a m -> m #

foldMap :: Monoid m => (a0 -> m) -> Forget r a a0 -> m #

foldMap' :: Monoid m => (a0 -> m) -> Forget r a a0 -> m #

foldr :: (a0 -> b -> b) -> b -> Forget r a a0 -> b #

foldr' :: (a0 -> b -> b) -> b -> Forget r a a0 -> b #

foldl :: (b -> a0 -> b) -> b -> Forget r a a0 -> b #

foldl' :: (b -> a0 -> b) -> b -> Forget r a a0 -> b #

foldr1 :: (a0 -> a0 -> a0) -> Forget r a a0 -> a0 #

foldl1 :: (a0 -> a0 -> a0) -> Forget r a a0 -> a0 #

toList :: Forget r a a0 -> [a0] #

null :: Forget r a a0 -> Bool #

length :: Forget r a a0 -> Int #

elem :: Eq a0 => a0 -> Forget r a a0 -> Bool #

maximum :: Ord a0 => Forget r a a0 -> a0 #

minimum :: Ord a0 => Forget r a a0 -> a0 #

sum :: Num a0 => Forget r a a0 -> a0 #

product :: Num a0 => Forget r a a0 -> a0 #

Traversable (Forget r a :: Type -> Type) # |
Instance details Defined in Data.Profunctor.Types Methods traverse :: Applicative f => (a0 -> f b) -> Forget r a a0 -> f (Forget r a b) # sequenceA :: Applicative f => Forget r a (f a0) -> f (Forget r a a0) # mapM :: Monad m => (a0 -> m b) -> Forget r a a0 -> m (Forget r a b) # sequence :: Monad m => Forget r a (m a0) -> m (Forget r a a0) #
Monoid r => Monoid (Forget r a b) # | Via `Monoid r => (a -> r)` Since: 5.6.2
Instance details Defined in Data.Profunctor.Types Methods mempty :: Forget r a b # mappend :: Forget r a b -> Forget r a b -> Forget r a b # mconcat :: [Forget r a b] -> Forget r a b #
Semigroup r => Semigroup (Forget r a b) # | Via `Semigroup r => (a -> r)` Since: 5.6.2
Instance details Defined in Data.Profunctor.Types Methods (<>) :: Forget r a b -> Forget r a b -> Forget r a b # sconcat :: NonEmpty (Forget r a b) -> Forget r a b # stimes :: Integral b0 => b0 -> Forget r a b -> Forget r a b #
type Rep (Forget r :: Type -> Type -> Type) # |
Instance details Defined in Data.Profunctor.Rep type Rep (Forget r :: Type -> Type -> Type) = Const r :: Type -> Type

type (:->) (p :: k -> k1 -> Type) (q :: k -> k1 -> Type) = forall (a :: k) (b :: k1). p a b -> q a b infixr 0 #

(`:->`) has a polymorphic kind since `5.6`.